Description

Developing and maintaining a wiki page I often would like to add some hidden commentary which does not show in formatted view.

I think there is no way to do this at the moment. Code for Textile Comments is filtered and does not work.

 

Disfunctional Textile examples:

comment blockcomment block

###. This is a textile comment block.

multi-line comment blockmulti-line comment block

###.. **********************

This multi-line comment

will keep going and going

even if you put blank lines in. **********************

 commented out blockcommented out block

Here is some text with a <!-- Commented out

1

 --> block.

<!-- Here is a single <span>line</span> comment block -->

<!-- Here is a whole

multiline

<span>HTML</span>

Comment

-->

Normal text continues here.

     

I know there is a plugin for this. I hope it will be made a core functionality soon. Cheers!

Related issues:

Related to Redmine - Feature #6269: RedCloth 4 support New

Related to Redmine - Feature #3564: Invisible comments Closed 2009-06-30

Related to Redmine - Defect #1160: HMTL-Tags Closed 2008-05-01

Associated revisions

Revision 21457 - 2022-03-17 04:55 - Go MAEDA

Comments for Textile text formatting (#20511).

2025-05-01 1/3

http://txstyle.org/doc/40/textile-comments


Patch by Go MAEDA.

History

#1 - 2016-11-29 03:59 - Serg Astra

+1

#2 - 2017-01-16 22:54 - Joel SCHAAL

I stumbled across the same issue today, and wondered what I was doing wrong.

This marks Textile as not fully supported by Redmine for me (contrarily to what is written here: Wiki formatting > Text formatting).

Is Textile going to be abandoned in favor of Markdown ? I guess this issue would then be obsolete...

#3 - 2021-02-10 12:05 - David Lukas Müller

+1

#4 - 2021-03-01 09:13 - Go MAEDA

- Related to Feature #6269: RedCloth 4 support added

#5 - 2021-03-01 09:15 - Go MAEDA

- Related to Feature #3564: Invisible comments added

#6 - 2022-02-03 09:18 - Go MAEDA

+1

CommonMark Markdown (#32424) that is going to be introduced in Redmine 5.0.0 supports HTML comments. I think it would be nice if Textile

supports HTML comments as well.

The following code adds HTML comments support to the Textile formatter.

diff --git a/lib/redmine/wiki_formatting/textile/redcloth3.rb b/lib/redmine/wiki_formatting/textile/redcloth3.

rb

index 2816e1c90..274f9cef8 100644

--- a/lib/redmine/wiki_formatting/textile/redcloth3.rb

+++ b/lib/redmine/wiki_formatting/textile/redcloth3.rb

@@ -298,6 +298,7 @@ class RedCloth3 < String

         @pre_list = []

         rip_offtags text

         no_textile text

+        clean_html_comment text

         escape_html_tags text

         # need to do this before #hard_break and #blocks

         block_textile_quotes text unless @lite_mode

@@ -1217,4 +1218,8 @@ class RedCloth3 < String

             end

         end

     end

+

+    def clean_html_comment(text)

+        text.gsub!(/^<!--[\s\S]*?-->$/, '')

+    end

 end

#7 - 2022-03-11 04:53 - Go MAEDA

- Related to Defect #1160: HMTL-Tags added

#8 - 2022-03-11 06:19 - Go MAEDA

- File 20511.patch added

- Target version set to Candidate for next major release

Here is a patch.

HTML comments in Textile are escaped since r1403. This patch may appear to roll back that change, but I think it is not a problem. This is because

the purpose of the change is to prevent mistakenly entered unclosed comments from affecting page rendering (see #1160) and unclosed comments

are still escaped even after applying the patch. It is ensured by the test source:trunk/test/helpers/application_helper_test.rb@21440#L1304.

#9 - 2022-03-15 01:52 - Go MAEDA
https://redmine.dwos.com/help/en-gb/wiki_syntax_detailed_textile.html#5
https://www.redmine.org/issues/32424
https://www.redmine.org/projects/redmine/repository/svn/revisions/1403
https://www.redmine.org/issues/1160
https://www.redmine.org/projects/redmine/repository/svn/revisions/21440/entry/trunk/test/helpers/application_helper_test.rb#L1304


- Target version changed from Candidate for next major release to 5.0.0

Setting the target version to 5.0.0.

#10 - 2022-03-17 04:55 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch.

Files

20511.patch 2.75 KB 2022-03-11 Go MAEDA
